输出

输出

exit调用错误时不会终止脚本..

输出

Error: Could not resolve localhost
after exit

脚本

#!/bin/sh

resolve_ip (){
    if [ -z "$1" ]; then
        host="localhost"
        ip=$(dig +short myip.opendns.com @resolver1.opendns.com)
    else
        host="$1"
        ip=$(dig +short $1)
    fi

    if [ -z "$ip" ]; then
        error "Could not resolve $host"
    fi

    echo "$ip"
}

error (){
    (>&2 echo "Error: $1")
    exit 1
}

master_host='google.com'

if [ "$(resolve_ip)" = "$(resolve_ip $master_host)" ]; then
    error "some error"
fi

echo "after exit"
exit

答案1

exit退出当前的 shell 进程。

在 中$(resolve_ip)resolve_ip正在子 shell 进程中运行。

你可以做:

my_ip=$(resolve_ip) || exit
master_ip=$(resolve_ip "$hostname") || exit
if [ "$my_ip" = "$master_ip" ]; ...

当子 shell 以非零退出状态退出时,主 shell 退出(使用与子 shell 相同的退出代码)。

此外,由于resolve_ip在子 shell 环境中运行,因此$ip$host变量在该子 shell 返回后将不再存在。

另请注意,(...)in(>&2 echo "Error: $1")还会启动一个子shell。这里实际上没有必要,除非您想涵盖 stderr 是损坏管道的情况,并且写入错误消息将导致 SIGPIPE 传递到主 shell 进程,就像echo内置的那样。

在这里,您可以通过将输出存储在用户提供的变量中来返回它,而不是通过 stdout 返回输出:

resolve_ip (){ # args: ip_var [host]
    if [ "$#" -eq 1 ]; then
        host=localhost
        eval "$1="'$(dig +short myip.opendns.com @resolver1.opendns.com)'
    else
        host=$2
        eval "$1="'$(dig +short "$2")'
    fi

    if eval '[ -z "${'"$1"'}" ]'; then
        error "Could not resolve $host"
    fi
}

# ...

resolve_ip my_ip
resolve_ip master_ip "$hostname"

if [ "$my_ip" = "$master_ip" ]; ...

严格来说,子 shell 环境不必通过子进程来实现,并且某些 shell 不ksh93作为优化,但仍然exit只退出子 shell,而不退出主 shell。ksh93但是有一个${ ...; }不涉及子 shell 环境的表单或命令替换,因此exit会退出主 shell。

相关内容